//---- input parameters
 extern bool trade = true;
 extern int slo = 5, mamode_slo = 2, maprice_slo = 0;
 extern int fast = 1, mamode_fast = 0, maprice_fast = 0;
 extern int sl = 60;
 extern int ts = 40;
 extern int tp = 500;
 extern int elevation = 3;
 extern int slippage = 5;
 extern double minp = 0;
 extern double lots = 0.1;
 extern bool constant_lot = true;
 extern double maxrisk = 0.1;
 extern int Magic = 777;
//
double lpf0;
double lpf1;
double hpf0;
double hpf1;
//
int start()
{
  if(!trade) return(0);
   if(Bars<100)   {Print("bars less than 100"); return(0);}
   if(!IsTradeAllowed()) {Sleep(120000); return(0);}
//--------------------------------------------------------------------------------------------//
   for(int i = OrdersTotal(); i >= 0; i--)
     {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES); 
       // check for symbol & magic number
       if(OrderSymbol()==Symbol() && OrderMagicNumber()== Magic) 
         {
           if(OrderType() == OP_BUY)  // long position is opened
            {
               if((OrderOpenPrice()-Ask)<Point*sl) // stoploss
                 {
                    OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Aqua);
                    return(0);
                 }
               if(detect()==-1) //close by sell condition
                 {
                    OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Lime);
                    return(0);
                 }
               if((Bid-OrderOpenPrice())>Point*(ts+minp)) //trail
                 {
                  if(OrderStopLoss()<(Bid-Point*ts))
                   {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*ts,OrderTakeProfit(),0,Orange);
                    return(0);
                   }
                 }
            } 
           if(OrderType() == OP_SELL)  // short position is opened
            {
               if((Bid-OrderOpenPrice())>Point*sl) // stoploss
                 {
                    OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Magenta);
                    return(0);
                 }
               if(detect()==1) //close by buy condition
                 {
                    OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Crimson);
                    return(0);
                 }
               if((OrderOpenPrice()-Ask)>Point*(ts+minp)) //trail
                {
                 if(OrderStopLoss()>(Ask+Point*ts))
                  {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*ts,OrderTakeProfit(),0,Orange);
                    return(0);
                  }
                }
            }
        }
     }
//new order
   if(OrdersTotal()>1) return(0);
   if(detect()==1)
     {
      OrderSend(Symbol(),OP_BUY,LotsOptimized(),Ask,slippage,0,Ask+tp*Point,WindowExpertName(),Magic,0,Green);
     }
   if(detect()==-1)
     {
      OrderSend(Symbol(),OP_SELL,LotsOptimized(),Bid,slippage,0,Bid-tp*Point,WindowExpertName(),Magic,0,Red);
     }
//
return(0);
}
//
double detect()
{
   RefreshRates();                             
//Free margin check
   int res = 0;
   double lotcost = MarketInfo(Symbol(),MODE_MARGINREQUIRED);//  1 
    if(AccountFreeMargin()<LotsOptimized()*lotcost) 
      {
         Print("Not enough funds, free margin = ", AccountFreeMargin());
         return(0);
      }
//
     lpf0 = iMA(Symbol(),0,slo,0,mamode_slo,maprice_slo,0);
     lpf1 = iMA(Symbol(),0,slo,0,mamode_slo,maprice_slo,1);
     hpf0 = iMA(Symbol(),0,fast,0,mamode_fast,maprice_fast,0);
     hpf1 = iMA(Symbol(),0,fast,0,mamode_fast,maprice_fast,1);
//-----------------   
   //if(MA_fast_0 > MA_slow_0 && MA_fast_1 <= MA_slow_1) _Ret = _Up;
   //if(MA_fast_0 < MA_slow_0 && MA_fast_1 >= MA_slow_1) _Ret = _Dn;//
   if((hpf0-elevation*Point)>lpf0 && hpf1<lpf1) res = 1;
   if((hpf0+elevation*Point)<lpf0 && hpf1>lpf1) res = -1;
   return(res);
}
//
double LotsOptimized()
{
   RefreshRates();                             
   double lot = lots;
   double minlot = MarketInfo(Symbol(), MODE_MINLOT);
   double maxlot = MarketInfo(Symbol(), MODE_MAXLOT);
   double lotstep = MarketInfo(Symbol(), MODE_LOTSTEP);
   double lotcost = MarketInfo(Symbol(),MODE_MARGINREQUIRED);
   if(!constant_lot)
    {
      lot = NormalizeDouble((AccountFreeMargin()*maxrisk)/lotcost,2);
      lot = lotstep*(MathRound(lot/lotstep));
      if(AccountFreeMargin()<lot*lotcost) lot = minlot;
      if(lot<minlot) lot = minlot;
      if(lot>maxlot) lot = maxlot;
      return(lot);
    } 
   else
    {
      if(lot<minlot) lot = minlot;
      if(lot>maxlot) lot = maxlot;
      return(lot);
    } 
}